  // Все о Коллекциях
  // Коллекции - это объекты, которые используются для хранения и организации группы элементов. Инными словами это массивы в разных вариациях (Set, Map, List)

void main(){
  // List. 
  // -Упорядоченная коллекция элементов.
  // - Элементы могут повторяться.
  // - Доступ к элементам осуществляется по индексу.  

  List<int> values = [1,2,3,4,3,5,6,7,8];
  print(values);
  values.add(9); // метод который добавляет в массив значение
  print(values);
  values.removeLast(); // метод который удаляет последнии значение в массиве
  print(values); 
  values.remove(3); // метод который удаляет определенное значение, которое при пробеге по массиву будет первым(в нашем случае это 3)
  print(values); 
  print(values.length); // dsdtltn длину массива
  // константы в коллекциях
  // константы вообще запрещено менять, по этому, если мы захотим как-то изменить константу, то при запуске приложения,
  // у нас выведет ошибку
  // List<int> constantList = const[1,3,5,7,9];
  // constantList.add(6); // Не поддерживающая операция add(). Запрещено изменять константы
  //print(constantList); // Выведет ошибку.
  

  // ОПЕРАТОРЫ
  // spread оператор. spread оператор используется для распаковки элементов из коллекций или итерируемых объектов.
  // записывается через три точки(...)

  var list1 = [3,2,1];
  var list2 = [4, ...list1];

  print(list2); // выведет массив [4,3,2,1]

  // Оператор ? также известный как оператор "наллабельности" (nullable operator),
  // используется для указания переменной или типа данных как
  // "nullable" (может быть null) или "non-nullable" (не может быть null).
  // Оператор ? добавляется после типа данных переменной или в объявлении параметра функции.


  // Оператор ? применяется для переменных, параметров функции и возвращаемых значений функций,
  // чтобы указать, может ли объект принимать значение null или нет.
  // Когда переменная или параметр объявлены как nullable (T?), они могут содержать null.
  // В противоположность этому, non-nullable (T) объекты не могут содержать null,
  // и компилятор будет выдавать ошибку, если мы попытаемся присвоить null non-nullable переменной.

  var nullList;
  var list3 = [1,2, ...?nullList];
  print(list3);

  // Условные конструкции внутри списка(и других коллекций). 
  // Вот несколько примеров использования условных конструкций внутри списков в Dart:
  
  // 1. Использование условной конструкции if:
  
  bool permission = true;
  var nav = ['home', 'about', if(permission) 'admin'];
  print(nav);

  List<int> numbersWithIf = [1, 2, 3, 4, 5];
  List<int> evenNumbersWithIf = [for (var number in numbersWithIf) if (number % 2 == 0) number];
  print(evenNumbersWithIf); // Выведет: [2, 4]

  // В этом примере используется условная конструкция if,
  // чтобы добавить только четные числа из списка numbers в список evenNumbers.

  // 2. Использование условной конструкции for и if:
  List<int> numbersWithForAndIf = [1, 2, 3, 4, 5];
  List<int> squaresOfEvenNumbersWithForAndIf = [
    for (var number in numbersWithForAndIf)
      if (number % 2 == 0) number * number
  ];
  print(squaresOfEvenNumbersWithForAndIf); // Выведет: [4, 16]

  //Здесь используется условная конструкция for и if для создания списка,
  // содержащего квадраты только четных чисел из списка numbers.

  //3. Использование спред-оператора (...) с условными конструкциями:

  List<int> numbersWithSpred = [1, 2, 3, 4, 5];
  List<int> filteredNumbersWithSpred = [...numbersWithSpred.where((number) => number % 2 == 0)];
  print(filteredNumbersWithSpred); // Выведет: [2, 4]

  // В этом примере коллекция numbers проходит фильтрацию с помощью where(),
  // возвращающую только четные числа, а затем спред-оператор (...) используется
  // для добавления отфильтрованных чисел в новый список filteredNumbers.

  // 4. Использование конструкции for

  List<int> intList = [1,2,2,3,4,5,5];
  List<String> strList = ['>0', for(var i in intList) '>$i'];
  print(strList); // Выведет: [>0, >1, >2, >2, >3, >4, >5, >5]

  // В этом примере мы создаем два списка, первый числовой (intList),
  // второй строковый(strList) и в нем мы, с помощью цикла, выводим значения с 1 списка.

}